unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Vcl.StdCtrls,
  VCLTee.TeEngine, VCLTee.Series, Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart,
  Vcl.Grids;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    StringGrid1: TStringGrid;
    NEdit: TLabeledEdit;
    NsetBtn: TButton;
    interpolationBtn: TButton;
    testdataBtn: TButton;
    XEdit: TLabeledEdit;
    Series1: TPointSeries;
    Series2: TLineSeries;
    Series3: TLineSeries;
    Series4: TLineSeries;
    Series5: TPointSeries;
    Xin_interpolation: TButton;
    RadioGroup1: TRadioGroup;
    minxEdit: TLabeledEdit;
    maxXEdit: TLabeledEdit;
    RadioGroup2: TRadioGroup;
    procedure testdataBtnClick(Sender: TObject);
    procedure NsetBtnClick(Sender: TObject);
    procedure interpolationBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Xin_interpolationClick(Sender: TObject);
  private
    { Private 錾 }
    procedure GridSet(Sin, Colin: integer);
    procedure FGridSet(Sin, Colin: integer);    // ObhTCYύX
    procedure ndisp;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses system.Math;

type
  DArray = array of double;

var
  x, y : Darray;          // x,y f[^[
  m, t : Darray;          // akoma       ԗpe[u
  z    : Darray;          // Cubic    @ ԃe[uf[^[@
  nt   : Darray;          // newtonian   ԃe[u
  lz   : Darray;          // Linear      ԌX΃e[u
  DEF  : Boolean;         // \tO
  xmax, xmin : double;    // xf[^[̍ől,ŏl
  dx   : double;          // Ot쐬px


// ObhTCY̕ύX
procedure TForm1.GridSet(Sin, Colin: integer);    // ObhTCYύX
var                                               // f[^[s̐10
  H, W :integer;                                  // ȏ̓XN[
begin
  if (StringGrid1.ColCount = Colin) and (StringGrid1.RowCount = Sin) then exit;
  StringGrid1.ColWidths[0] := 30;
  StringGrid1.ColCount := Colin;
  StringGrid1.RowCount := Sin;
  if Sin <= 11 then                               // XgOObh̑傫ݒ
    begin                                         // Œs܂11s͂ȉ̏ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * Sin;
      W := (StringGrid1.DefaultColWidth + 1) * (Colin - 1) + 31;
      StringGrid1.ScrollBars := ssNone;           // XN[o[Ȃ
    end
  else
    begin                                         // Œs܂11s葽ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * (10 + 1);
      W := (StringGrid1.DefaultColWidth + 1) * (Colin - 1) + 31;
      StringGrid1.ScrollBars := ssVertical;       // XN[o[\
    end;
  StringGrid1.ClientWidth := W;
  StringGrid1.ClientHeight := H;
end;

// ObhŒs̐ݒ
procedure TForm1.FGridSet(Sin, Colin: integer);
var
  E : integer;
begin
  GridSet(Sin, Colin);
  for E := 1 to Sin - 1 do
      StringGrid1.Rows[E].Text := intTostr(E);
  StringGrid1.Cols[1].Text := 'x';
  StringGrid1.Cols[2].Text := 'y';
end;

// x̒l`FbN x̒l邩mF l true L false
function datacheck(x :DArray; N: integer): boolean;
var
  i, j : integer;
begin
  result := false;
  for i := 0 to N - 1 do
    for j := 0 to N - 1 do begin
      if i <> j then
        if x[i] - x[j] = 0 then begin
          application.MessageBox(pchar('x' + inttostr(i+1) + '-x' + inttostr(j+1)
                                         + '[ɂȂ܂B'),'',0);
          exit;
        end;
    end;
  for i := 0 to N - 2 do
    if x[i] > x[i + 1] then begin
      application.MessageBox(pchar('x' + inttostr(i+1) + '>x' + inttostr(i+2)
                                    + #13#10 +'l̑傫tłB'),'',0);
      exit;
    end;
  result := true;
end;

// G[ result < 0
function Ninput: integer;
var
  N, ch : integer;
begin
  result := -1;
  val(Form1.Nedit.Text, N, ch);
  if ch <> 0 then begin
    application.MessageBox('N̓͂ɊԈႢL܂B','',0);
    exit;
  end;
  if N > 100 then begin
    application.MessageBox('N100ɂĉB','',0);
    exit;
  end;
  if N < 3 then begin
    application.MessageBox('N3ȏɂĉB','',0);
    exit;
  end;
  Form1.GridSet(N + 1, 3);
  result := N;
end;

// ObhNZbg
procedure TForm1.NsetBtnClick(Sender: TObject);
begin
  ninput;
end;

// Qllf(x) QۊmFpf[^[
function f2(x: double): double;
begin
  result := 1 / (1 + 2 * x * x);
end;

// Qll cos(x)
function f1(x: double): double;
begin
  result := cos(x);
end;

// Qll̊֐
function f(x:Double):Double;
begin
  result := x - power(x,3) / 5 + power(x,5) / 100;
end;

// Qll Zbg
procedure TForm1.testdataBtnClick(Sender: TObject);
var
  N, ch : integer;
  i : integer;
  d, dx : double;
  minx, maxx : double;
begin
  if radiogroup1.ItemIndex < 3 then begin
    N := Ninput;
    if N < 0 then exit;
    val(minxedit.Text, minx, ch);
    if ch <> 0 then begin
      application.MessageBox('minlɊԈႢL܂B','',0);
      exit;
    end;
    val(maxxedit.Text, maxx, ch);
    if ch <> 0 then begin
      application.MessageBox('maxlɊԈႢL܂B','',0);
      exit;
    end;
    if minx >= maxx then begin
      application.MessageBox('maxlminl菬łB','',0);
      exit;
    end;
    if radiogroup1.ItemIndex < 3 then begin
      setlength(x, N);
      setlength(y, N);
      dx := (maxx - minx) / (N - 1);
      for i := Low(x) to High(x) do begin
        d   := i * dx + minx;
        x[i] := d;
        case radiogroup1.ItemIndex of
          0 : y[i] := f(d);
          1 : y[i] := f1(d);
          2 : y[i] := f2(d);
        end;
        StringGrid1.cells[1,i + 1] := floatTostr(x[i]);
        StringGrid1.cells[2,i + 1] := floatTostr(y[i]);
      end;
    end;
    DEF := True;                        // Ot\tO
  end;
  if radiogroup1.ItemIndex = 3 then begin
    N := 9;               // f[^[
    Nedit.Text := inttostr(N);
    GridSet(N + 1, 3);
    setlength(x, N);
    setlength(y, N);
    x[0] := -2  ;  y[0] :=  0.4;
    x[1] := -1.8;  y[1] :=  0.4;
    x[2] := -1.1;  y[2] :=  0.45;
    x[3] := -0.9;  y[3] :=  0.76;
    x[4] := -0.3;  y[4] :=  0.8;
    x[5] :=  0.15; y[5] :=  1;
    x[6] :=  0.4;  y[6] :=  0.8;
    x[7] :=  0.5;  y[7] :=  0.5;
    x[8] :=  0.9;  y[8] :=  0.5;
    for i := 0 to N - 1 do begin
      StringGrid1.cells[1,i + 1] := floatTostr(x[i]);
      StringGrid1.cells[2,i + 1] := floatTostr(y[i])
    end;
    DEF := false;                        // Ot\tO
  end;
  interpolationBtnClick(Nil);
end;

// LinearX΃e[u쐬
procedure Linear_maketable;
var
  i, p : integer;
begin
  p := high(x);
  for i := 0 to p - 1 do lz[i] := (y[i + 1] - y[i]) / (x[i + 1] - x[i]);
end;

// Linear
// x[] xf[^[z
// y[] yf[^[z
// lz[] XΔz
function Linear_interpolation(xx: double): double;
var
  iB, iM, iT: integer;
  a : double;
begin
  iB := low(x);                       // x[] bottom zno
  iT := high(x);                      // x[] topzNo
  // xxl̏㉺̔zx̔zԍT
  // XX<x[iB]̏ꍇԉ̋ XX>x[iT]̏ꍇԏ̋
  while (iT - iB) > 1 do begin
    iM := (iB + iT) div 2;            // middlezno
    if x[iM] > xx then
      iT := iM
    else
      iB := iM;
  end;
  a := xx - x[iB];                    // x[iB]x̒l
  result := y[iB] + lz[iB] * a;
end;

// j[gWe[uݒ
// x[] xf[^[z
// y[] yf[^[z
// nt[] Wz
procedure Newtonian_maketabler;    // Wntɏ㏑
var
  i, j, P : integer;
begin
  p := high(x);
  for i := 1 to P do
    for j := P downto i do
      nt[j] := (nt[j] - nt[j - 1]) / (x[j] - x[j - i]);
end;

// j[gԌvZ
// x[] xf[^[z
// nt[] Wz
function interpolate(xx: double): double;  // 
var
  i, P : integer;
  r, s : double;
begin
  p := high(x);
  r := nt[0];
  s := 1;
  for i := 1 to P do begin
    s := s * (xx - x[i - 1]);
    r := r + s * nt[i];
  end;
  result := r
end;

// natural e[uz쐬
// x[] xf[^[z
// y[] yf[^[z
// z[] Wz
procedure maketable;
var
	i, N : integer;
	t : double;
	h, d: DArray;
begin
  N := high(x) + 1;
  setlength(h, N);
  setlength(d, N);
  for i := 0 to  N - 2 do begin
		h[i    ] :=  x[i + 1] - x[i];
		d[i + 1] := (y[i + 1] - y[i]) / h[i];
	end;
	z[0] := 0;
  z[N - 1] := 0;                  // y''(x)[̒l 0
	z[1] := d[2] - d[1];
	d[1] := 2 * (x[2] - x[0]);
	for i := 1 to  N - 3 do  begin
		t := h[i] / d[i];
		z[i + 1] := d[i + 2] - d[i + 1] - z[i] * t;
		d[i + 1] := 2 * (x[i + 2] - x[i]) - h[i] * t;
	end;
	z[N - 2] := z[N - 2] - h[N - 2] * z[N - 1];
	for i := N - 2 downto 1 do
		z[i] := (z[i] - h[i] * z[i + 1]) / d[i];
end;

// natural Spline 
// t xx̒l
// x[] xf[^[z
// y[] yf[^[z
// z[] Wz
function spline(t: double): double;
var
	i, j, k: integer;
	d, h: double;
begin
  j := high(x);
	i := 0;
  // Ԋ֐lǂ̋Ԃɂ邩
	while i < j do begin
		k := (i + j) div 2;
    if x[k] < t then i := k + 1
                else j := k;
  end;
	if i > 0 then  dec(i);
  // ԒlvZ
	h := x[i + 1] - x[i];
  d := t - x[i];
	result := (((z[i + 1] - z[i]) * d / h + z[i] * 3) * d
		        + ((y[i + 1] - y[i]) / h
		        - (z[i] * 2 + z[i + 1]) * h)) * d + y[i];
end;

// akima m,t e[u쐬
// x[] xf[^[z
// y[] yf[^[z
// m[] mWe[u
// t[] tWe[u
procedure akima_table;
var
  ii, n : integer;
  a, b,  half : double;
begin
  n := high(x) + 1;
  half := 1 / 2;                // 0.5
  // shift data by + 2 in the array and compute the secants
  // also calculate extrapolated and end point secants
  // X΃[  y/x
  for ii := 0 to n - 2 do
    m[ii + 2] := (y[ii + 1] - y[ii]) / (x[ii + 1] - x[ii]);
  // [_XΏ
  m[1] := 2 * m[2] - m[3];
  m[0] := 2 * m[1] - m[2];
  m[n + 1] := 2 * m[n] - m[n - 1];
  m[n + 2] := 2 * m[n + 1] - m[n];
  // e|CǧXΌWvZ
  for ii := 0 to n - 1 do begin
    a := abs(m[ii + 3] - m[ii + 2]);
    b := abs(m[ii + 1] - m[ii]);
    if (a + b) <> 0 then
      t[ii] := (a * m[ii + 1] + b * m[ii + 2]) / (a + b)
    else
      t[ii] := half * (m[ii + 2] + m[ii + 1]);
  end;
end;

// akima ԒlvZ
// xx x̒l
// x[] xf[^[z
// y[] yf[^[z
// m[] mWe[u
// t[] tWe[u
// result Ԓly'
function akima_Interpolation(xx: double): double;
var
  iB, iM, iT: integer;
  a, b : double;
begin
  iB := low(x);                       // x[] bottom zno
  iT := high(x);                      // x[] topzNo
  // xxl̏㉺̔zx̔zԍT
  // XX<x[iB]̏ꍇԉ̋ XX>x[iT]̏ꍇԏ̋
  while (iT - iB) > 1 do begin
    iM := (iB + iT) div 2;            // middlezno
    if x[iM] > xx then
      iT := iM
    else
      iB := iM;
  end;
  b := x[iT] - x[iB];                 // Ԃx̕ω
  a := xx - x[iB];                    // x[iB]x̒l
  // 3akima spline vZ
  result :=   y[iB]
            + t[iB] * a
            + (3 * m[iB + 2] - 2 * t[iB] - t[iB + 1]) * a * a / b
            + (t[iB] + t[iB + 1] - 2 * m[iB + 2]) * a * a * a / (b * b);
end;

// ԌvZI\
procedure TForm1.ndisp;
begin
  case radiogroup2.ItemIndex of
    0 : Chart1.Title.Text.Text := 'Akima Spline Interpolation';
    1 : Chart1.Title.Text.Text := 'Natural Spline Interpolation';
    2 : Chart1.Title.Text.Text := 'Newtonian Interpolation';
    3 : Chart1.Title.Text.Text := 'Linear interpolation';
  end;
end;

// IԌvZ
function Interpolation(xx: double): double;
begin
  result := 0;
  case Form1.radiogroup2.ItemIndex of
    0 : result := akima_Interpolation(xx);      // akima ԌvZ
    1 : result := spline(xx);                   // natural ԌvZ
    2 : result := interpolate(xx);              // newton ԌvZ
    3 : result := Linear_interpolation(xx);
  end;
end;

// Obh̒lɂԌvZ
procedure TForm1.interpolationBtnClick(Sender: TObject);
var
  N, ch, i, imax : integer;
  cn : string;
  y2, y3 : double;
  xx : double;
begin
  Xin_interpolation.Enabled := False;
  N := Ninput;
  if N < 0 then exit;
  setlength(x, N);
  setlength(y, N);
  setlength(m, N + 3);              // Akimap
  setlength(t, N);                  // Akimap
  setlength(z, N);                  // naturalp
  setlength(nt, N);                 // newtonp
  setlength(lz, N - 1);             // Linearp

  for i := Low(x) to High(x) do begin
    val(StringGrid1.cells[1,i + 1], x[i], ch);
    if ch <> 0 then begin
      cn := 'x' + intTostr(i + 1) + 'ɊԈႢL܂B';
      application.MessageBox(pchar(cn),'',0);
      break;
    end;
    val(StringGrid1.cells[2,i + 1], y[i], ch);
    if ch <> 0 then begin
      cn := 'y' + intTostr(i + 1) + 'ɊԈႢL܂B';
      application.MessageBox(pchar(cn),'',0);
      break;
    end;
  end;
  if ch <> 0 then exit;
  if not datacheck(x, N) then exit;           // x̒lɏdmF

  Series1.Clear;                              // vbgl
  Series2.Clear;                              // eXgvZl
  Series3.Clear;                              // Ԓl
  Series4.Clear;                              // eXglƕԒl
  Series5.Clear;                              // w_vZl

  xmin := x[0];
  xmax := x[0];
  for i := Low(x) to High(x) do begin
    if x[i] > xmax then xmax := x[i];
    if x[i] < xmin then xmin := x[i];
    Series1.AddXY(x[i], y[i]);                // f[^[|Cg\
    nt[i] := y[i];                            // newtonpe[u쐬pɃRs[
  end;

  akima_table;                                // akima e[u쐬
  maketable;                                  // natural e[u쐬
  Newtonian_maketabler;                       // newton e[u쐬
  Linear_maketable;                           // Linear@e[u쐬
  ndisp;                                      // IԖ\

  imax := N * 20;                       // 
  dx := (xmax - xmin) / imax;
  y2 := 0;
  for i := 0 to imax do begin
    xx := i * dx + x[0];                      // x'
    y3 := Interpolation(xx);                  // ԌvZ
    Series3.AddXY(xx, y3);
    if DEF then begin
      case radiogroup1.ItemIndex of
        0 : y2 := f(xx);
        1 : y2 := f1(xx);
        2 : y2 := f2(xx);
      end;
      Series2.AddXY(xx, y2);                  // eXgl
      Series4.AddXY(xx, y3 - y2);             // l l-eXgl
    end;
  end;
  DEF := False;
  Xin_interpolation.Enabled := True;
end;

// wľvZ wlxɂyԒlvZƃOt\
procedure TForm1.Xin_interpolationClick(Sender: TObject);
var
  ch, i, j : integer;
  xd, y1, y3, xx, gmin, gmax: double;
begin
  val(Xedit.Text, xd, ch);
  if ch <> 0 then begin
    application.MessageBox('xY̓͂ɊԈႢL܂B','',0);
    exit;
  end;

  Series2.Clear;                              // eXglOt
  Series3.Clear;                              // ԒlOt
  Series4.Clear;                              // l
  Series5.Clear;                              // wl_

  ndisp;                                      // IԖ\

  // ŏőԃOtĕ`
  gmin := xmin;
  gmax := xmax;
  if xd < xmin then gmin := xd;
  if xd > gmax then gmax := xd;
  i := round((gmax - gmin) / dx);
  for j := 0 to i do begin
    xx := j * dx + gmin;                      // x'
    y3 := Interpolation(xx);                  // ԌvZ
    Series3.AddXY(xx, y3);
  end;
  // wl_Otǉ wlxɂyԒlvZƃOt\
  y1 := Interpolation(xd);                    // ԌvZ
  Series5.AddXY(xd, y1);
end;

// Obhݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  FGridSet(101, 3);                 // Œs11 + 100s2܂ōsύXĂ
                                    // ͒lNAȂ悤ɂ܂B
  GridSet(4, 3);                    // ŏ̐ݒ
end;

end.
